<?php

defined('_VALID_CALL') or die('Direct Access is not allowed.');

// kco_order been created in hook module_checkout.php_checkout_first.php
global $kco_order, $store_handler;
if(is_object($kco_order))
{
    try
    {
        /**
         * save klarna (checkout) order in db
         */
        klarna_kco::setKlarnaOrderInXt($kco_order, $order->oID);

        /**
         * acknowledge order in klarna and set merchant ref1 to xt's order id
         */
        klarna_kco::setXtOrderIdInKlarna($kco_order['order_id'], $order->oID);
        klarna_kco::acknowledgeOrder($kco_order['order_id']);
        /**
         * fetch klarna order an save in xt db
         */
        $order_management = klarna_kco::getOrder($kco_order['order_id']);
        klarna_kco::setKlarnaOrderInXt($order_management, $order->oID);

        $kco_order_status = $order_management['status'] == 'CANCELLED' ? 'CANCELED' : $order_management['fraud_status'];
        $mapped_xt_status = xt_klarna_kco::getMappedXtOrderStatus($kco_order_status, $store_handler->shop_id);
        if($mapped_xt_status && (int)$mapped_xt_status != (int)$order->order_data['orders_status_id'])
        {
            $order2update = new order();
            $order2update->oID = $order->oID;
            $order2update->_updateOrderStatus($mapped_xt_status,'', false, false, 'klarna status mapping', 0, '');
            // $order_history = $this->_getOrderHistory($oID);
            //$record->fields['status_name']=$system_status->values['order_status'][$record->fields['orders_status_id']]['name'];
            //$record->fields['status_image']=$system_status->values['order_status'][$record->fields['orders_status_id']]['image'];
        }

        $order->order_data['payment_name'] = 'Klarna';
    }
    catch(Exception $ex)
    {
        error_log($ex->getMessage());
    }
}
